module.exports = function(RED) {
    var ModbusRTU = require('modbus-serial');
    function ModbusWritNode(config) {
        RED.nodes.createNode(this,config);
        var node = this;
        node.on('input', function(msg) {

            var client = new ModbusRTU();
            // open connection to a tcp line
            client.connectTCP(msg.Ip, { port: 502 });
            client.setID(1);
            client.setTimeout(1000);

            function close() {
                client.close();
            }

            setTimeout(function() {

            client.writeRegisters(msg.Address, [msg.Value])
            .then(function(d) {
                msg.payload = "success";
                msg.status = d;
                node.status({fill:"green",shape:"dot",text:"success"});
                node.send(msg);
             })
            .catch(function(e) {
                msg.payload = "failed";
                msg.status = e;
                node.status({fill:"red",shape:"dot",text:"failed"});
                node.send(msg);
             })
            .then(close);

            }, 100);


        });
    }
    RED.nodes.registerType("modbus-custom-write",ModbusWritNode);
}